replace UuidAndTitleCacheTaxonComparator by type save implementation
03/26/2020 11:31 AM - Andreas Kohlbecker
Target version: Release 5.14

Severity: normal

Description

copied from #8892:
UuidAndTitleCacheTaxonComparator is used by different methods which pass Object array with different content:

e TaxonNodeDaoHibernatelmpl.getTaxonNodeDto(Integer limit, String pattern, UUID classificationUuid) ==> tn.uuid, tn.id,
t.titleCache, t.name, rank

¢ TaxonNodeDaoHibernatelmpl.getTaxonNodeUuidAndTitleCacheOfAcceptedTaxaByClassification(..) ==> nodes.uuid, nodes.id,
taxon.titleCache, taxon.name, rank

¢ TaxonNodeDaoHibernatelmpl.getUuidAndTitleCache(Integer limit, String pattern, UUID classificationUuid) ==> 'tn.uuid, tn.id,
t.titleCache, name, name_rank'

¢ TaxonDaoHibernatelmpl.getUuidAndTitleCache ==> tb.uuid, tb.id, tb.titteCache, tb.name.rank BUG: rank is passed instead of
name here!

¢ |dentifiableDaoBase.getUuidAndTitleCache ==> uuid, id, titleCache SCARY: It seems as if this comparator has initially been
used to compare arbitrary IndentifieableEntities. for my feeling this comparator is too much overloaded

Since UuidAndTitleCacheTaxonComparator is used a lot by methods it is quite unsave that it takes object arrays as parameters. We
need a comparator for more specific dto class instead.

Suggested solution:
e create specific comparator SortableTaxonNodeQueryResultComparator implements
Comparator<SortableTaxonNodeQueryResult> whereas SortableTaxonNodeQueryResult is a sortable dto which will never
leave the persistence layer.

Additinal task:

¢ clean up TaxonNodeDaoHibernatelmplTest.findWithoutRank.xml from unused data

Related issues:
Related to EDIT - bug #9053: CCE when selecting Character Tree for descriptiv... Closed

Copied from EDIT - bug #8892: Taxon search does not work for names without rank Closed

Associated revisions

Revision db026829 - 03/26/2020 03:44 PM - Andreas Kohlbecker
ref #8907 SortableTaxonNodeQueryResultComparator to replace UuidAndTitleCacheTaxonComparator

Revision f4f6d97b - 03/26/2020 03:44 PM - Andreas Kohlbecker
ref #8907 SortableTaxonNodeQueryResultComparator to replace UuidAndTitleCacheTaxonComparator - step 2

Revision 49bfebfd - 03/26/2020 03:58 PM - Andreas Kohlbecker
ref #8907 cleaning up test data

Revision 79ff326b - 03/26/2020 05:19 PM - Andreas Kohlbecker
ref #8907 basing testGetTaxonNodeUuidAndTitleCacheOfacceptedTaxaByClassificationForNameWithoutRank on

TaxonNodeDaoHibernatelmplTest.findWithoutRank.xml

Revision 3¢c9af367 - 03/30/2020 12:31 PM - Andreas Kohlbecker
ref #8907 adding missing constructor to hgl query

Revision 5db2ebcd - 03/30/2020 04:06 PM - Andreas Kohlbecker
ref #8907 adapting method to SortableTaxonNodeQueryResult and fixing NPE

Revision f84a4e81 - 03/30/2020 04:21 PM - Andreas Kohlbecker
ref #8907 adapting method to SortableTaxonNodeQueryResult - adding test

History

#1 - 03/26/2020 11:31 AM - Andreas Kohlbecker

- Copied from bug #8892: Taxon search does not work for names without rank added

#2 - 03/26/2020 11:32 AM - Andreas Kohlbecker

- Description updated

#3 - 03/26/2020 05:19 PM - Andreas Kohlbecker

- Subject changed from replace UuidAndTitleCacheTaxonComparator by typesave implementation to replace UuidAndTitleCache TaxonComparator by
type save implementation

- Status changed from New to Resolved
- Assignee changed from Andreas Kohlbecker to Andreas Mliller

- % Done changed from 0 to 50

ticket completed.

#4 - 06/04/2020 10:02 AM - Katja Luther
- Related to bug #9053: CCE when selecting Character Tree for descriptive dataset added
